---
title: Array.prototype.values()
slug: Web/JavaScript/Reference/Global_Objects/Array/values
tags:
  - Array
  - Beginner
  - ECMAScript 2015
  - Iterator
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>values()</code></strong> method returns a new <strong><code>Array Iterator</code></strong> object that contains the values for each index in the array.</p>

<div>{{EmbedInteractiveExample("pages/js/array-values.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>arr</var>.values()</pre>

<h3 id="Return_value">Return value</h3>

<p>A new {{jsxref("Array")}} iterator object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Iteration_using_for...of_loop">Iteration using for...of loop</h3>

<pre class="brush: js notranslate">var arr = ['a', 'b', 'c', 'd', 'e'];
var iterator = arr.values();

for (let letter of iterator) {
  console.log(letter);
}  //"a" "b" "c" "d" "e"
</pre>

<p><strong>Array.prototype.values</strong> is default implementation of <strong>Array.prototype[Symbol.iterator]</strong>.</p>

<pre class="notranslate">Array.prototype.values === Array.prototype[Symbol.iterator]      //true</pre>

<h3 id="Iteration_using_.next">Iteration using .next()</h3>

<pre class="brush: js notranslate">var arr = ['a', 'b', 'c', 'd', 'e'];
var iterator = arr.values();
iterator.next();               // Object { value: "a", done: false }
iterator.next().value;         // "b"
iterator.next()["value"];      // "c"
iterator.next();               // Object { value: "d", done: false }
iterator.next();               // Object { value: "e", done: false }
iterator.next();               // Object { value: undefined, done: true }
iteraror.next().value;         // undefined </pre>

<div class="notecard warning">
<p>One-use: the array iterator object is one use or temporary object</p>
</div>

<p>example:</p>

<pre class="brush: js notranslate">var arr = ['a', 'b', 'c', 'd', 'e'];
 var iterator = arr.values();
 for (let letter of iterator) {
 console.log(letter);
} //"a" "b" "c" "d" "e"
for (let letter of iterator) {
console.log(letter);
} // undefined
</pre>

<p><strong>reason:</strong> When <code>next().done=true</code>  or  <code>currentIndex&gt;length</code> the <code>for..of</code> loop ends. See <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">Iteration protocols.</a></p>

<p><strong>Value</strong>: there are no values stored in the array Iterator object; instead it stores the address of the array used in its creation and so depends on the values stored in that array.</p>

<pre class="brush: js notranslate">var arr = ['a', 'b', 'c', 'd', 'e'];
var iterator = arr.values();
console.log(iterator);        // Array Iterator {  }
iterator.next().value;        // "a"
arr[1]='n';
iterator.next().value;        //  "n"
</pre>

<div class="notecard note">
<p>if the values in the array changed the array iterator object values change too.</p>
</div>

<p class="hidden"><strong>TODO</strong>: please write about why we need it, use cases.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.values', 'Array.prototype.values')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.values")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.keys()")}}</li>
 <li>{{jsxref("Array.prototype.entries()")}}</li>
 <li>{{jsxref("Array.prototype.forEach()")}}</li>
 <li>{{jsxref("Array.prototype.every()")}}</li>
 <li>{{jsxref("Array.prototype.some()")}}</li>
</ul>
